
/*]  Copyright (c) 2009-2010, Charles McGarvey  [**************************
**]  All rights reserved.
*
* vi:ts=4 sw=4 tw=75
*
* Distributable under the terms and conditions of the 2-clause BSD license;
* see the file COPYING for a complete text of the license.
*
**************************************************************************/

#ifndef _GAMESTATE_HH_
#define _GAMESTATE_HH_

/**
 * \file GameState.hh
 * The data.
 */

#include <string>
#include <vector>

#include <boost/shared_ptr.hpp>

#include <moof/camera.hh>
#include <moof/interpolator.hh>
#include <moof/script.hh>

#include "Character.hh"
#include "Heroine.hh"
#include "Scene.hh"


struct GameState
{
	moof::script				script;
	std::vector<std::string>	sceneList;

	HeroineP					heroine;
	SceneP						scene;

	moof::lerp_scalar			interp;

	moof::camera				camera;
};


#endif // _GAMESTATE_HH_

